Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/GPS.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/GPS.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/GPS.pm	(revision 34921)
@@ -13,5 +13,5 @@
 use Image::ExifTool::Exif;
 
-$VERSION = '1.34';
+$VERSION = '1.52';
 
 my %coordConv = (
@@ -39,4 +39,9 @@
         Name => 'GPSLatitudeRef',
         Writable => 'string',
+        Notes => q{
+            tags 0x0001-0x0006 used for camera location according to MWG 2.0. ExifTool
+            will also accept a number when writing GPSLatitudeRef, positive for north
+            latitudes or negative for south, or a string ending in N or S
+        },
         Count => 2,
         PrintConv => {
@@ -46,6 +51,6 @@
                 my ($val, $inv) = @_;
                 return undef unless $inv;
-                return uc $1 if $val =~ /\b([NS])$/i;
-                return $1 eq '-' ? 'S' : 'N' if $val =~ /^([-+]?)\d+(\.\d*)?$/;
+                return uc $1 if $val =~ /\b([NS])\b/i;
+                return $1 eq '-' ? 'S' : 'N' if $val =~ /([-+]?)\d+/;
                 return undef;
             },
@@ -64,4 +69,8 @@
         Writable => 'string',
         Count => 2,
+        Notes => q{
+            ExifTool will also accept a number when writing this tag, positive for east
+            longitudes or negative for west, or a string ending in E or W
+        },
         PrintConv => {
             # extract E/W if written from Composite:GPSLongitude
@@ -70,6 +79,6 @@
                 my ($val, $inv) = @_;
                 return undef unless $inv;
-                return uc $1 if $val =~ /\b([EW])$/i;
-                return $1 eq '-' ? 'W' : 'E' if $val =~ /^([-+]?)\d+(\.\d*)?$/;
+                return uc $1 if $val =~ /\b([EW])\b/i;
+                return $1 eq '-' ? 'W' : 'E' if $val =~ /([-+]?)\d+/;
                 return undef;
             },
@@ -87,5 +96,14 @@
         Name => 'GPSAltitudeRef',
         Writable => 'int8u',
-        PrintConv => {
+        Notes => q{
+            ExifTool will also accept number when writing this tag, with negative
+            numbers indicating below sea level
+        },
+        PrintConv => {
+            OTHER => sub {
+                my ($val, $inv) = @_;
+                return undef unless $inv and $val =~ /^([-+0-9])/;
+                return($1 eq '-' ? 1 : 0);
+            },
             0 => 'Above Sea Level',
             1 => 'Below Sea Level',
@@ -107,13 +125,15 @@
         Shift => 'Time',
         Notes => q{
-            when writing, date is stripped off if present, and time is adjusted to UTC
-            if it includes a timezone
+            UTC time of GPS fix.  When writing, date is stripped off if present, and
+            time is adjusted to UTC if it includes a timezone
         },
         ValueConv => 'Image::ExifTool::GPS::ConvertTimeStamp($val)',
         ValueConvInv => '$val=~tr/:/ /;$val',
+        PrintConv => 'Image::ExifTool::GPS::PrintTimeStamp($val)',
         # pull time out of any format date/time string
         # (converting to UTC if a timezone is given)
         PrintConvInv => sub {
-            my $v = shift;
+            my ($v, $et) = @_;
+            $v = $et->TimeNow() if lc($v) eq 'now';
             my @tz;
             if ($v =~ s/([-+])(.*)//s) {    # remove timezone
@@ -210,9 +230,7 @@
         Name => 'GPSDestLatitudeRef',
         Writable => 'string',
-        Count => 2,
-        PrintConv => {
-            N => 'North',
-            S => 'South',
-        },
+        Notes => 'tags 0x0013-0x001a used for subject location according to MWG 2.0',
+        Count => 2,
+        PrintConv => { N => 'North', S => 'South' },
     },
     0x0014 => {
@@ -226,8 +244,5 @@
         Writable => 'string',
         Count => 2,
-        PrintConv => {
-            E => 'East',
-            W => 'West',
-        },
+        PrintConv => { E => 'East', W => 'West' },
     },
     0x0016 => {
@@ -268,5 +283,5 @@
         Writable => 'undef',
         Notes => 'values of "GPS", "CELLID", "WLAN" or "MANUAL" by the EXIF spec.',
-        RawConv => 'Image::ExifTool::Exif::ConvertExifText($self,$val)',
+        RawConv => 'Image::ExifTool::Exif::ConvertExifText($self,$val,1,$tag)',
         RawConvInv => 'Image::ExifTool::Exif::EncodeExifText($self,$val)',
     },
@@ -274,5 +289,5 @@
         Name => 'GPSAreaInformation',
         Writable => 'undef',
-        RawConv => 'Image::ExifTool::Exif::ConvertExifText($self,$val)',
+        RawConv => 'Image::ExifTool::Exif::ConvertExifText($self,$val,1,$tag)',
         RawConvInv => 'Image::ExifTool::Exif::EncodeExifText($self,$val)',
     },
@@ -281,11 +296,12 @@
         Groups => { 2 => 'Time' },
         Writable => 'string',
-        Notes => 'YYYY:mm:dd',
+        Format => 'undef', # (Casio EX-H20G uses "\0" instead of ":" as a separator)
         Count => 11,
         Shift => 'Time',
         Notes => q{
             when writing, time is stripped off if present, after adjusting date/time to
-            UTC if time includes a timezone
-        },
+            UTC if time includes a timezone.  Format is YYYY:mm:dd
+        },
+        RawConv => '$val =~ s/\0+$//; $val',
         ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
         ValueConvInv => '$val',
@@ -294,4 +310,5 @@
         PrintConvInv => q{
             my $secs;
+            $val = $self->TimeNow() if lc($val) eq 'now';
             if ($val =~ /[-+]/ and ($secs = Image::ExifTool::GetUnixTime($val, 1))) {
                 $val = Image::ExifTool::ConvertUnixTime($secs);
@@ -315,4 +332,6 @@
         Writable => 'rational64u',
     },
+    # 0xea1c - Nokia Lumina 1020, Samsung GT-I8750, and other Windows 8
+    #          phones write this (padding) in GPS IFD - PH
 );
 
@@ -352,5 +371,5 @@
     },
     GPSAltitude => {
-        SubDoc => 1,    # generate for all sub-documents
+        SubDoc => [1,3], # generate for sub-documents if Desire 1 or 3 has a chance to exist
         Desire => {
             0 => 'GPS:GPSAltitude',
@@ -364,11 +383,28 @@
             my $alt = $val[0];
             $alt = $val[2] unless defined $alt;
-            return undef unless defined $alt;
-            return ($val[1] || $val[3]) ? -$alt : $alt;
+            return undef unless defined $alt and IsFloat($alt);
+            return(($val[1] || $val[3]) ? -$alt : $alt);
         },
         PrintConv => q{
             $val = int($val * 10) / 10;
-            return ($val =~ s/^-// ? "$val m Below" : "$val m Above") . " Sea Level";
-        },
+            return(($val =~ s/^-// ? "$val m Below" : "$val m Above") . " Sea Level");
+        },
+    },
+    GPSDestLatitude => {
+        Require => {
+            0 => 'GPS:GPSDestLatitude',
+            1 => 'GPS:GPSDestLatitudeRef',
+        },
+        ValueConv => '$val[1] =~ /^S/i ? -$val[0] : $val[0]',
+        PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "N")',
+    },
+    GPSDestLongitude => {
+        SubDoc => 1,    # generate for all sub-documents
+        Require => {
+            0 => 'GPS:GPSDestLongitude',
+            1 => 'GPS:GPSDestLongitudeRef',
+        },
+        ValueConv => '$val[1] =~ /^W/i ? -$val[0] : $val[0]',
+        PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "E")',
     },
 );
@@ -388,12 +424,25 @@
     $h = int($f / 3600); $f -= $h * 3600;
     $m = int($f / 60);   $f -= $m * 60;
-    $s = int($f);        $f -= $s;
-    $f = int($f * 1000000 + 0.5);
-    if ($f) {
-        ($f = sprintf(".%.6d", $f)) =~ s/0+$//;
+    my $ss = sprintf('%012.9f', $f);
+    if ($ss >= 60) {
+        $ss = '00';
+        ++$m >= 60 and $m -= 60, ++$h;
     } else {
-        $f = ''
+        $ss =~ s/\.?0+$//;  # trim trailing zeros + decimal
     }
-    return sprintf("%.2d:%.2d:%.2d$f",$h,$m,$s);
+    return sprintf("%.2d:%.2d:%s",$h,$m,$ss);
+}
+
+#------------------------------------------------------------------------------
+# Print GPS timestamp
+# Inputs: 0) EXIF-formatted time string
+# Returns: time rounded to the nearest microsecond
+sub PrintTimeStamp($)
+{
+    my $val = shift;
+    return $val unless $val =~ s/:(\d{2}\.\d+)$//;
+    my $s = int($1 * 1000000 + 0.5) / 1000000;
+    $s = "0$s" if $s < 10;
+    return "${val}:$s";
 }
 
@@ -406,11 +455,19 @@
 sub ToDMS($$;$$)
 {
-    my ($exifTool, $val, $doPrintConv, $ref) = @_;
-    my ($fmt, $num);
-
+    my ($et, $val, $doPrintConv, $ref) = @_;
+    my ($fmt, @fmt, $num, $sign, $rtnVal);
+
+    unless (length $val) {
+        # don't convert an empty value
+        return $val if $doPrintConv and $doPrintConv eq '1';  # avoid hiding existing tag when extracting
+        return undef; # avoid writing empty value
+    }
     if ($ref) {
         if ($val < 0) {
             $val = -$val;
             $ref = {N => 'S', E => 'W'}->{$ref};
+            $sign = '-';
+        } else {
+            $sign = '+';
         }
         $ref = " $ref" unless $doPrintConv and $doPrintConv eq '2';
@@ -421,24 +478,51 @@
     if ($doPrintConv) {
         if ($doPrintConv eq '1') {
-            $fmt = ($exifTool->Options('CoordFormat') || q{%d deg %d' %.2f"}) . $ref;
+            $fmt = $et->Options('CoordFormat');
+            if (not $fmt) {
+                $fmt = q{%d deg %d' %.2f"} . $ref;
+            } elsif ($ref) {
+                # use signed value instead of reference direction if specified
+                $fmt =~ s/%\+/$sign%/g or $fmt .= $ref;
+            } else {
+                $fmt =~ s/%\+/%/g;  # don't know sign, so don't print it
+            }
         } else {
-            $fmt = "%d,%.6f$ref";   # use XMP standard format
+            $fmt = "%d,%.8f$ref";   # use XMP format with 8 decimal minutes
         }
-        # count the number of format specifiers
-        $num = ($fmt =~ tr/%/%/);
+        # count (and capture) the format specifiers (max 3)
+        while ($fmt =~ /(%(%|[^%]*?[diouxXDOUeEfFgGcs]))/g) {
+            next if $1 eq '%%';
+            push @fmt, $1;
+            last if @fmt >= 3;
+        }
+        $num = scalar @fmt;
     } else {
         $num = 3;
     }
-    my ($d, $m, $s);
-    $d = $val;
+    my @c;  # coordinates (D) or (D,M) or (D,M,S)
+    $c[0] = $val;
     if ($num > 1) {
-        $d = int($d);
-        $m = ($val - $d) * 60;
+        $c[0] = int($c[0]);
+        $c[1] = ($val - $c[0]) * 60;
         if ($num > 2) {
-            $m = int($m);
-            $s = ($val - $d - $m / 60) * 3600;
+            $c[1] = int($c[1]);
+            $c[2] = ($val - $c[0] - $c[1] / 60) * 3600;
+        }
+        # handle round-off errors to ensure minutes and seconds are
+        # less than 60 (eg. convert "72 59 60.00" to "73 0 0.00")
+        $c[-1] = $doPrintConv ? sprintf($fmt[-1], $c[-1]) : ($c[-1] . '');
+        if ($c[-1] >= 60) {
+            $c[-1] -= 60;
+            ($c[-2] += 1) >= 60 and $num > 2 and $c[-2] -= 60, $c[-3] += 1;
         }
     }
-    return $doPrintConv ? sprintf($fmt, $d, $m, $s) : "$d $m $s$ref";
+    if ($doPrintConv) {
+        $rtnVal = sprintf($fmt, @c);
+        # trim trailing zeros in XMP
+        $rtnVal =~ s/(\d)0+$ref$/$1$ref/ if $doPrintConv eq '2';
+    } else {
+        $rtnVal = "@c$ref";
+    }
+    return $rtnVal;
 }
 
@@ -451,7 +535,9 @@
 {
     my ($val, $doSign) = @_;
+    return '' if $val =~ /\b(inf|undef)\b/; # ignore invalid values
     # extract decimal or floating point values out of any other garbage
     my ($d, $m, $s) = ($val =~ /((?:[+-]?)(?=\d|\.\d)\d*(?:\.\d*)?(?:[Ee][+-]\d+)?)/g);
-    my $deg = ($d || 0) + (($m || 0) + ($s || 0)/60) / 60;
+    return '' unless defined $d;
+    my $deg = $d + (($m || 0) + ($s || 0)/60) / 60;
     # make negative if S or W coordinate
     $deg = -$deg if $doSign ? $val =~ /[^A-Z](S|W)$/i : $deg < 0;
@@ -479,5 +565,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/GeoTiff.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/GeoTiff.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/GeoTiff.pm	(revision 34921)
@@ -5,8 +5,11 @@
 #
 # Revisions:    02/23/2004 - P. Harvey Created
-#               02/25/2004 - P. Harvey Added new codes from libgeotiff-1.2.1
-#               02/01/2007 - P. Harvey Added new codes from libgeotiff-1.2.3
+#               02/25/2004 - PH Added new codes from libgeotiff-1.2.1
+#               02/01/2007 - PH Added new codes from libgeotiff-1.2.3
+#               01/22/2014 - PH Added new code from libgeotiff-1.4.0
+#               01/19/2015 - PH Added ChartTIFF tags
 #
-# Reference:    ftp://ftp.remotesensing.org/geotiff/libgeotiff/libgeotiff-1.1.4.tar.gz
+# References:   1) ftp://ftp.remotesensing.org/geotiff/libgeotiff/libgeotiff-1.1.4.tar.gz
+#               2) http://www.charttiff.com/whitepapers.shtml
 #------------------------------------------------------------------------------
 
@@ -17,9 +20,10 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.07';
+$VERSION = '1.12';
 
 # format codes for geoTiff directory entries
 my %geoTiffFormat = (
-    0      => 'int16u',
+    0      => 'int16u', # (value is stored in offset, and count is 1)
+    0x87af => 'int16u', # (value is stored after directory)
     0x87b0 => 'double',
     0x87b1 => 'string',
@@ -50,4 +54,47 @@
     9107 => 'Angular DMS',
     9108 => 'Angular DMS Hemisphere',
+    32767 => 'User Defined',
+);
+
+my %epsg_vertcs = (
+    0 => 'Undefined',
+    5001 => 'Airy 1830 ellipsoid',
+    5002 => 'Airy Modified 1849 ellipsoid',
+    5003 => 'ANS ellipsoid',
+    5004 => 'Bessel 1841 ellipsoid',
+    5005 => 'Bessel Modified ellipsoid',
+    5006 => 'Bessel Namibia ellipsoid',
+    5007 => 'Clarke 1858 ellipsoid',
+    5008 => 'Clarke 1866 ellipsoid',
+    5010 => 'Clarke 1880 Benoit ellipsoid',
+    5011 => 'Clarke 1880 IGN ellipsoid',
+    5012 => 'Clarke 1880 RGS ellipsoid',
+    5013 => 'Clarke 1880 Arc ellipsoid',
+    5014 => 'Clarke 1880 SGA 1922 ellipsoid',
+    5015 => 'Everest 1830 1937 Adjustment ellipsoid',
+    5016 => 'Everest 1830 1967 Definition ellipsoid',
+    5017 => 'Everest 1830 1975 Definition ellipsoid',
+    5018 => 'Everest 1830 Modified ellipsoid',
+    5019 => 'GRS 1980 ellipsoid',
+    5020 => 'Helmert 1906 ellipsoid',
+    5021 => 'INS ellipsoid',
+    5022 => 'International 1924 ellipsoid',
+    5023 => 'International 1967 ellipsoid',
+    5024 => 'Krassowsky 1940 ellipsoid',
+    5025 => 'NWL 9D ellipsoid',
+    5026 => 'NWL 10D ellipsoid',
+    5027 => 'Plessis 1817 ellipsoid',
+    5028 => 'Struve 1860 ellipsoid',
+    5029 => 'War Office ellipsoid',
+    5030 => 'WGS 84 ellipsoid',
+    5031 => 'GEM 10C ellipsoid',
+    5032 => 'OSU86F ellipsoid',
+    5033 => 'OSU91A ellipsoid',
+    5101 => 'Newlyn',
+    5102 => 'North American Vertical Datum 1929',
+    5103 => 'North American Vertical Datum 1988',
+    5104 => 'Yellow Sea 1956',
+    5105 => 'Baltic Sea',
+    5106 => 'Caspian Sea',
     32767 => 'User Defined',
 );
@@ -505,4 +552,5 @@
     },
     2061 => 'GeogPrimeMeridianLong',
+    2062 => 'GeogToWGS84',
     3072 => {
         Name => 'ProjectedCSType',
@@ -526,4 +574,6 @@
             3057 => 'ISN93 Lambert 1993',
             3300 => 'Estonian Coordinate System of 1992',
+            3786 => 'Popular Visualisation CRS / Mercator', #PH (NC)
+            3857 => 'WGS 84 / Pseudo-Mercator', #PH (NC)
             20137 => 'Adindan UTM zone 37N',
             20138 => 'Adindan UTM zone 38N',
@@ -556,5 +606,5 @@
             20538 => 'Afgooye UTM zone 38N',
             20539 => 'Afgooye UTM zone 39N',
-            20700 => 'Lisbon Portugese Grid',
+            20700 => 'Lisbon Portuguese Grid',
             20822 => 'Aratu UTM zone 22S',
             20823 => 'Aratu UTM zone 23S',
@@ -2006,54 +2056,12 @@
     4096 => {
         Name => 'VerticalCSType',
-        PrintConv => {
-            # epsg_vertcs
-            5001 => 'Airy 1830 ellipsoid',
-            5002 => 'Airy Modified 1849 ellipsoid',
-            5003 => 'ANS ellipsoid',
-            5004 => 'Bessel 1841 ellipsoid',
-            5005 => 'Bessel Modified ellipsoid',
-            5006 => 'Bessel Namibia ellipsoid',
-            5007 => 'Clarke 1858 ellipsoid',
-            5008 => 'Clarke 1866 ellipsoid',
-            5010 => 'Clarke 1880 Benoit ellipsoid',
-            5011 => 'Clarke 1880 IGN ellipsoid',
-            5012 => 'Clarke 1880 RGS ellipsoid',
-            5013 => 'Clarke 1880 Arc ellipsoid',
-            5014 => 'Clarke 1880 SGA 1922 ellipsoid',
-            5015 => 'Everest 1830 1937 Adjustment ellipsoid',
-            5016 => 'Everest 1830 1967 Definition ellipsoid',
-            5017 => 'Everest 1830 1975 Definition ellipsoid',
-            5018 => 'Everest 1830 Modified ellipsoid',
-            5019 => 'GRS 1980 ellipsoid',
-            5020 => 'Helmert 1906 ellipsoid',
-            5021 => 'INS ellipsoid',
-            5022 => 'International 1924 ellipsoid',
-            5023 => 'International 1967 ellipsoid',
-            5024 => 'Krassowsky 1940 ellipsoid',
-            5025 => 'NWL 9D ellipsoid',
-            5026 => 'NWL 10D ellipsoid',
-            5027 => 'Plessis 1817 ellipsoid',
-            5028 => 'Struve 1860 ellipsoid',
-            5029 => 'War Office ellipsoid',
-            5030 => 'WGS 84 ellipsoid',
-            5031 => 'GEM 10C ellipsoid',
-            5032 => 'OSU86F ellipsoid',
-            5033 => 'OSU91A ellipsoid',
-            5101 => 'Newlyn',
-            5102 => 'North American Vertical Datum 1929',
-            5103 => 'North American Vertical Datum 1988',
-            5104 => 'Yellow Sea 1956',
-            5105 => 'Baltic Sea',
-            5106 => 'Caspian Sea',
-            32767 => 'User Defined',
-        },
+        SeparateTable => 'VerticalCS',
+        PrintConv => \%epsg_vertcs,
     },
     4097 => 'VerticalCitation',
     4098 => {
         Name => 'VerticalDatum',
-        PrintConv => {
-            1 => 'Vertical Datum Base',
-            32767 => 'User Defined',
-        },
+        SeparateTable => 'VerticalCS',
+        PrintConv => \%epsg_vertcs,
     },
     4099 => {
@@ -2062,4 +2070,60 @@
         PrintConv => \%epsg_units,
     },
+#
+# ChartTiff extensions (ref 2)
+#
+    47001 => {
+        Name => 'ChartFormat',
+        PrintConv => {
+            47500 => 'General',
+            47501 => 'Coastal',
+            47502 => 'Harbor',
+            47503 => 'SailingInternational',
+            47504 => 'SmallCraft Route',
+            47505 => 'SmallCraftArea',
+            47506 => 'SmallCraftFolio',
+            47507 => 'Topographic',
+            47508 => 'Recreation',
+            47509 => 'Index',
+            47510 => 'Inset',
+        },
+    },
+    47002 => 'ChartSource',
+    47003 => 'ChartSourceEdition',
+    47004 => 'ChartSourceDate',
+    47005 => 'ChartCorrDate',
+    47006 => 'ChartCountryOrigin',
+    47007 => 'ChartRasterEdition',
+    47008 => {
+        Name => 'ChartSoundingDatum',
+        PrintConv => {
+            47600 => 'Equatorial Spring Low Water',
+            47601 => 'Indian Spring Low Water',
+            47602 => 'Lowest Astronomical Tide',
+            47603 => 'Lowest Low Water',
+            47604 => 'Lowest Normal Low Water',
+            47605 => 'Mean Higher High Water',
+            47606 => 'Mean High Water',
+            47607 => 'Mean High Water Springs',
+            47608 => 'Mean Lower Low Water',
+            47609 => 'Mean Lower Low Water Springs',
+            47610 => 'Mean Low Water',
+            47611 => 'Mean Sea Level',
+            47612 => 'Tropic Higher High Water',
+            47613 => 'Tropic Lower Low Water',
+        },
+    },
+    47009 => {
+        Name => 'ChartDepthUnits',
+        SeparateTable => 'Units',
+        PrintConv => \%epsg_units,
+    },
+    47010 => 'ChartMagVar',
+    47011 => 'ChartMagVarYear',
+    47012 => 'ChartMagVarAnnChange',
+    47013 => 'ChartWGSNSShift',
+    47015 => 'InsetNWPixelX',
+    47016 => 'InsetNWPixelY',
+    47017 => 'ChartContourInterval',
 );
 
@@ -2069,11 +2133,15 @@
 sub ProcessGeoTiff($)
 {
-    my $exifTool = shift;
-    my $dirData = $exifTool->GetValue('GeoTiffDirectory', 'ValueConv') or return;
-    my $doubleData = $exifTool->GetValue('GeoTiffDoubleParams', 'ValueConv');
-    my $asciiData = $exifTool->GetValue('GeoTiffAsciiParams', 'ValueConv');
-    my $verbose = $exifTool->Options('Verbose');
-
-    # restore or original EXIF byte order setting
+    my $et = shift;
+    my $dirData = $et->GetValue('GeoTiffDirectory', 'ValueConv') or return;
+
+    # avoid re-processing if another EXIF directory is found
+    $$et{DidGeoTiff} and $$et{DidGeoTiff} eq $dirData and return;
+    $$et{DidGeoTiff} = $dirData;
+
+    my $doubleData = $et->GetValue('GeoTiffDoubleParams', 'ValueConv');
+    my $asciiData = $et->GetValue('GeoTiffAsciiParams', 'ValueConv');
+    my $verbose = $et->Options('Verbose');
+
     if (length($$dirData) >= 8 and
         length($$dirData) >= 8 * (Get16u($dirData,6) + 1))
@@ -2085,11 +2153,11 @@
 
         if ($verbose) {
-            $exifTool->{INDENT} .= '| ';
-            $exifTool->VerboseDir('GeoTiff',$numEntries);
+            $$et{INDENT} .= '| ';
+            $et->VerboseDir('GeoTiff',$numEntries);
         }
         # generate version number tag (not a real GeoTiff tag)
         my $tagTable = GetTagTable("Image::ExifTool::GeoTiff::Main");
-        my $tagInfo = $exifTool->GetTagInfo($tagTable, 1);
-        $tagInfo and $exifTool->FoundTag($tagInfo,"$version.$revision.$minorRev");
+        my $tagInfo = $et->GetTagInfo($tagTable, 1);
+        $tagInfo and $et->FoundTag($tagInfo,"$version.$revision.$minorRev");
 
         my $i;
@@ -2097,5 +2165,5 @@
             my $pt = 8 * ($i + 1);
             my $tag    = Get16u($dirData, $pt);
-            $tagInfo   = $exifTool->GetTagInfo($tagTable, $tag) or next;
+            $tagInfo   = $et->GetTagInfo($tagTable, $tag) or next;
             my $loc    = Get16u($dirData, $pt+2);
             my $count  = Get16u($dirData, $pt+4);
@@ -2103,22 +2171,29 @@
             my $format = $geoTiffFormat{$loc};
             my ($val, $dataPt);
-            if ($format eq 'double') {          # in the double parms
+            if (not $format) {
+                $et->Warn("Unknown GeoTiff location ($loc) for $$tagInfo{Name}");
+                next;
+            } elsif ($format eq 'double') {     # in the double parms
                 $dataPt = $doubleData;
-                $offset *= 8;
-                $val = Image::ExifTool::ReadValue($dataPt, $offset, $format,
-                                                  $count, length($$doubleData)-$offset);
             } elsif ($format eq 'string') {     # in the ASCII parms
                 $dataPt = $asciiData;
-                $val = substr($$dataPt, $offset, $count);
-                $val =~ s/(\0|\|)$//;   # remove trailing terminator (NULL or '|')
-            } elsif ($format eq 'int16u') {     # use the offset as the value
+            } elsif ($format eq 'int16u') {     # in the GeoTiffDirectory data
                 $dataPt = $dirData;
-                $val = $offset;
-                $offset = $pt+6;
-            } else {
-                $exifTool->Warn("Unknown GeoTiff location: $loc");
+                unless ($loc) {                 # is value is stored in offset?
+                    $count = 1;                 # (implied by location of 0)
+                    $offset = ($pt + 6) / 2;    # offset of the "offset" value
+                }
+            }
+            my $size = Image::ExifTool::FormatSize($format);
+            if (not $dataPt or length($$dataPt) < $size*($offset+$count)) {
+                $et->Warn("Missing $format data for $$tagInfo{Name}");
                 next;
             }
-            $verbose and $exifTool->VerboseInfo($tag, $tagInfo,
+            $offset *= $size;
+            $val = Image::ExifTool::ReadValue($dataPt, $offset, $format,
+                                              $count, length($$dataPt)-$offset);
+            # remove trailing terminator (NULL or '|') from string value
+            $val =~ s/(\0|\|)$// if $format eq 'string';
+            $verbose and $et->VerboseInfo($tag, $tagInfo,
                 'Table'  => $tagTable,
                 'Index'  => $i,
@@ -2128,19 +2203,20 @@
                 'Format' => $format,
                 'Count'  => $count,
-                'Size'   => $count * Image::ExifTool::FormatSize($format),
+                'Size'   => $count * $size,
             );
-            $exifTool->FoundTag($tagInfo, $val);
+            $et->FoundTag($tagInfo, $val);
         }
         if ($verbose) {
-            $exifTool->{INDENT} =~ s/..$//;
+            $$et{INDENT} =~ s/..$//;
         }
     } else {
-        $exifTool->Warn('Bad GeoTIFF directory');
+        $et->Warn('Bad GeoTIFF directory');
     }
-    # must delete these tags once we've processed this information
-    # (to avoid re-processing if another EXIF directory is found)
-    $exifTool->DeleteTag('GeoTiffDirectory');
-    $exifTool->DeleteTag('GeoTiffDoubleParams');
-    $exifTool->DeleteTag('GeoTiffAsciiParams');
+    # extract block tags only if requested
+    unless ($$et{OPTIONS}{RequestAll}) {
+        $et->DeleteTag('GeoTiffDirectory')    unless $$et{REQ_TAG_LOOKUP}{geotiffdirectory};
+        $et->DeleteTag('GeoTiffDoubleParams') unless $$et{REQ_TAG_LOOKUP}{geotiffdoubleparams};
+        $et->DeleteTag('GeoTiffAsciiParams')  unless $$et{REQ_TAG_LOOKUP}{geotiffasciiparams};
+    }
 }
 
@@ -2167,5 +2243,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -2178,4 +2254,6 @@
 =item ftp://ftp.remotesensing.org/geotiff/libgeotiff/libgeotiff-1.1.4.tar.gz
 
+=item http://www.charttiff.com/whitepapers.shtml
+
 =back
 
